---
title: Introduction to HTML5 Game Development (summary)
slug: Games/Introduction_to_HTML5_Game_Development_(summary)
tags:
  - Firefox OS
  - Games
  - HTML5
  - Mobile
---
<div>{{GamesSidebar}}</div>

<div>
<h2 id="Advantages" style="line-height: 30px;">Advantages</h2>

<ol>
 <li><span class="seoSummary">Games built with HTML5 work on smartphones, tablets, PCs and Smart TVs.</span></li>
 <li>Advertise and promote your game all over the Web as well as other media.</li>
 <li>Payments. Charge what you want and use whatever payment processing service you like.</li>
 <li><span class="seoSummary">Update your game whenever you want.</span></li>
 <li>Collect your own analytics!</li>
 <li>Connect with your customers more closely,</li>
 <li><span class="seoSummary">Players can play the game anywhere, anytime.</span></li>
</ol>

<h2 id="Web_Technologies" style="line-height: 30px;">Web Technologies</h2>
</div>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col" style="text-align: left;"><strong>Function</strong></th>
   <th scope="col" style="text-align: left;"><strong>Technology</strong></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><strong>Audio</strong></td>
   <td><a href="/en-US/docs/Web_Audio_API">Web Audio API</a></td>
  </tr>
  <tr>
   <td><strong>Graphics</strong></td>
   <td><a href="/en-US/docs/WebGL">WebGL</a> (<a href="http://www.khronos.org/opengles/">OpenGL ES</a> 2.0)</td>
  </tr>
  <tr>
   <td><strong>Input</strong></td>
   <td><a href="/en-US/docs/DOM/Touch_events">Touch events</a>, <a href="/en-US/docs/API/Gamepad/Using_Gamepad_API">Gamepad API</a>, device sensors, <a href="/en-US/docs/WebRTC">WebRTC</a>, <a href="/en-US/docs/DOM/Using_fullscreen_mode">Full Screen API</a>, <a href="/en-US/docs/WebAPI/Pointer_Lock">Pointer Lock API</a></td>
  </tr>
  <tr>
   <td><strong>Language</strong></td>
   <td><a href="/en-US/docs/JavaScript">JavaScript</a> (or C/C++ using <a href="https://github.com/kripken/emscripten/wiki">Emscripten</a> to compile to JavaScript)</td>
  </tr>
  <tr>
   <td><strong>Networking</strong></td>
   <td><a href="/en-US/docs/WebRTC">WebRTC</a> and/or <a href="/en-US/docs/WebSockets">WebSockets</a></td>
  </tr>
  <tr>
   <td><strong>Storage</strong></td>
   <td><a href="/en-US/docs/IndexedDB">IndexedDB</a> or the "cloud"</td>
  </tr>
  <tr>
   <td><strong>Web</strong></td>
   <td><a href="/en-US/docs/HTML">HTML</a>, <a href="/en-US/docs/CSS">CSS</a>, <a href="/en-US/docs/SVG">SVG</a>, <a href="/en-US/docs/Social_API">Social API</a> (and much more!)</td>
  </tr>
 </tbody>
</table>

<div class="twocolumns">
<dl>
 <dt><a href="/en-US/docs/DOM/Using_fullscreen_mode">Full Screen API</a></dt>
 <dd>Full screen gameplay.</dd>
 <dt><a href="/en-US/docs/API/Gamepad/Using_Gamepad_API">Gamepad API</a></dt>
 <dd>Use gamepads or other game controllers.</dd>
 <dt><a href="/en-US/docs/HTML">HTML</a> and <a href="/en-US/docs/CSS">CSS</a></dt>
 <dd>Build, style, and lay out your game's user interface.</dd>
 <dt><a href="/en-US/docs/HTML/Element/audio">HTML audio</a></dt>
 <dd>Easily play simple sound effects and music.</dd>
 <dt><a href="/en-US/docs/IndexedDB">IndexedDB</a></dt>
 <dd>Store user data on their own computer or device.</dd>
 <dt><a href="/en-US/docs/JavaScript">JavaScript</a></dt>
 <dd>Fast web programming language to write the code for your game.<br>
 To easily port your existing games <a href="https://github.com/kripken/emscripten/wiki">Emscripten</a> or <a href="http://asmjs.org/spec/latest/">Asm.js</a></dd>
 <dt><a href="/en-US/docs/WebAPI/Pointer_Lock">Pointer Lock API</a></dt>
 <dd>Lock the mouse or other pointing device within your game's interface.</dd>
 <dt><a href="/en-US/docs/SVG">SVG</a> (Scalable Vector Graphics)</dt>
 <dd>Build vector graphics that scale smoothly regardless of the size or resolution of the user's display.</dd>
 <dt><a href="/en-US/docs/JavaScript/Typed_arrays">Typed Arrays</a></dt>
 <dd>Access raw binary data from within JavaScript; Manipulate GL textures, game data, or anything else.</dd>
 <dt><a href="/en-US/docs/Web_Audio_API">Web Audio API</a></dt>
 <dd>Control the playback, synthesis, and manipulation of audio in real time.</dd>
 <dt><a href="/en-US/docs/WebGL">WebGL</a></dt>
 <dd>Create high-performance, hardware-accelerated 3D (and 2D) graphics. <a href="http://www.khronos.org/opengles/">OpenGL ES</a> 2.0.</dd>
 <dt><a href="/en-US/docs/WebRTC">WebRTC</a></dt>
 <dd>Real-Time Communications to control audio and video data, including teleconferencing and transmitting other application data back and forth between two users like chat.</dd>
 <dt><a href="/en-US/docs/WebSockets">WebSockets</a></dt>
 <dd>Connect your app or site to a server to transmit data back and forth in real-time. Perfect for multiplayer gaming action, chat services, and so forth.</dd>
 <dt><a href="/en-US/docs/DOM/Using_web_workers">Web Workers</a></dt>
 <dd>Spawn background threads running their own JavaScript code for multi-core processors.</dd>
 <dt><a href="/en-US/docs/DOM/XMLHttpRequest">XMLHttpRequest</a> and <a href="/en-US/docs/DOM/File_API">File API</a></dt>
 <dd>Send and receive any kind of data you want from a Web server like downloading new game levels and artwork to transmitting non-real-time game status information back and forth.</dd>
</dl>
</div>
